<?php
  // Composer autoload
  require_once LIBS_DIR . '/composer/autoload.php';

  // PEAR
  require_once LIBS_DIR . "/composer/pear-pear.php.net/PEAR/PEAR.php";
//  require_once "PEAR/Exception.php";
  // databaze
  require_once LIBS_DIR . "/composer/pear-pear.php.net/MDB2/MDB2.php";

  // konfigurace
  require_once CONF_DIR . '/general.inc.php';
  // zakladni funkce
  require_once INC_DIR . '/basefunc.php';
  // zpracovani chyb
  require_once INC_DIR . '/error.php';

  // Viper2
  require_once LIBS_DIR . '/composer/viper2/core/Viper2.php';
  require_once LIBS_DIR . '/composer/viper2/core/Viper2Plugin.php';
  require_once LIBS_DIR . '/composer/viper2/core/Viper2Router.php';
  require_once LIBS_DIR . '/MDB2_Explain.php';

  // Session
  require_once LIBS_DIR . '/mysql_session.php';
  // Cache handler
  require_once LIBS_DIR . '/Smarty_Cache_Mysql.php';
  
  // define("DEBUG_SQL", TRUE);
  define("WEB_DEBUG", TRUE);
  
  // define("_WEB_MAINTENANCE", TRUE);
  
  if (preg_match("/^\/(_[a-z]+)\//", $_SERVER["REQUEST_URI"], $match)) {
    if ($match[1]!="_dev" && $match[1]!="X_fish") {
      define("_WEB_DEBUG", TRUE);
    }
  }
  if (!defined("_WEB_DEBUG")) {
    $old_error_handler = set_error_handler("my_error_handler");
  }
  
  forceNoCache();

  function PEAR_ErrorToPEAR_Exception($err) {
    if ($err->getCode()) {
      throw new Exception($err->getMessage()." ".$err->getUserInfo(), $err->getCode());
    }
    throw new Exception($err->getMessage()." ".$err->getUserInfo());
  }
  PEAR::setErrorHandling(PEAR_ERROR_CALLBACK, 'PEAR_ErrorToPEAR_Exception');
  
  define("_DATA_PATH", WWW_DIR."/data");
  
  function autoloader($class)
  {
    $filename = LIBS_DIR.DIRECTORY_SEPARATOR.str_replace('\\', DIRECTORY_SEPARATOR, $class).'.php';
    if (file_exists($filename)) {
      require_once $filename;
    } else {
      throw new \Exception("Class '".$class."' failed to autoload");
    }
  }
  spl_autoload_register('autoloader');  

  
  try {
    // DB init
    $dbh = MDB2::connect($DB_DSN,$DB_OPTIONS);
    if (PEAR::isError($dbh)) {
      die($dbh->getMessage());
    }
    $dbh->setFetchMode(MDB2_FETCHMODE_ASSOC);
    $dbh->query("SET CHARACTER SET utf8");
    $dbh->query("SET NAMES utf8");
    Viper2::$dbh = $dbh;
    Viper2::$dbh->loadModule('Extended');
    Viper2::$addShortLinks = TRUE;

    
    if (defined('DEBUG_SQL')) {    
      // instance of the custom debug handler
      $my_debug_handler = new Explain_Queries($dbh);
      // set debug option
      $dbh->setOption('debug', 1);
      // set debug handler to the method that
      // collects all queries
      $dbh->setOption(
        'debug_handler',
        array($my_debug_handler, 'collectInfo')
      );
      // register functions to be executed on shut down
      // after the script has finished execution.
      // Now that the show's over, it's the time to
      // report what happened in this script db-access-wise
      // First shutdown function executes the
      // SELECTs again, the other one prints the results
      register_shutdown_function(
        array($my_debug_handler, 'executeAndExplain')
      );
      register_shutdown_function(
        array($my_debug_handler, 'dumpInfo')
      );
    }
 
    $sess = &new mysql_session($dbh->getConnection());
    
    //@todo: presunout do vipera
    function getAuthorizationKey() {
      $session = NULL;
      $headers = apache_request_headers();
      if (isset($headers["X-Authorization"])) {
        if (preg_match("/^Viper2 (.+)$/", $headers["X-Authorization"], $match)) {
          $rawKey = $match[1];
          //@todo: validace klice, kontrola timestampu
          $session = $rawKey; 
        }
      }
      return $session;
    }
    
    $connectionId = getAuthorizationKey();
    if (isset($connectionId)) {
      session_id($connectionId);
    }

    // @todo: misto nulovani agenta zrusit kontrolu v session
    $_SERVER["HTTP_USER_AGENT"] = "";
    session_start();

    
    // SMARTY init
    $smarty = new Smarty;
    $smarty->use_sub_dirs = TRUE;
    $smarty->caching = 0;
    $smarty->cache_dir = TMP_DIR . '/cache';
    $smarty->compile_dir = TMP_DIR . '/templates_c';
    $smarty->plugins_dir = array(
                                 APP_DIR . '/plugins',
                                 SMARTY_DIR . 'plugins'
                                 );
    $smarty->template_dir = APP_DIR . '/templates';

    $cacheHandler = &new Smarty_Cache_Mysql($dbh->getConnection());
    $smarty->cache_handler_func = array($cacheHandler, "handler");
    
    Viper2::$useSmarty = TRUE;
    Viper2::$smartyCache = 0;
    Viper2::$smarty = $smarty;
    
    $stime=microtime_float();
    // plugin load
//    Viper2::init(LIBS_DIR."/Viper2", CONF_DIR."/Viper2");

    Viper2::init(array(LIBS_DIR."/composer/viper2", LIBS_DIR."/Viper2"), CONF_DIR."/Viper2");

    // $smarty->clear_compiled_tpl("dummy.tpl");
    function search_template ($resource_type, $resource_name, &$template_source, &$template_timestamp, &$smarty_obj)
    {
      if( $resource_type == 'file' ) {
        // var_dump($resource_name);
        // var_dump(Viper2::getPluginPaths());
        $pluginPaths = Viper2::getPluginPaths();
        foreach ($pluginPaths as $pluginPath) {
          foreach (array_reverse($pluginPath) as $path) {
            $tplPath = $path."/templates/".$resource_name;
            if (is_readable($tplPath)) {
              // create the template file, return contents.
              $template_source = file_get_contents($tplPath);
              $template_timestamp = filemtime($tplPath);
              return true;
            }
          }
        }
      } else {
        // not a file
        return false;
      }
      return false;
    }
    
    // set the default handler
    $smarty->default_template_handler_func = 'search_template';    
    
    // router init
    $router = Viper2Router::getInstance();
    Viper2::initRouter($router);
    
    $cacheHandler->setNameSpace(Viper2::$router->userFolder());
    
    if(defined("_WEB_MAINTENANCE")){
      Viper2::$router->transferTo("Default::maintenance");
    }
    

   
    // -- application ---------------------------------------------
    

    Viper2::processActions();
   
    Viper2::processShow();
    
    // echo Viper2::$router;
    
    Viper2::renderLayout();
      
  } catch(Exception $e) {
    define("_GOT_ERROR", TRUE);
    if (defined("_WEB_DEBUG")) {
      echo "Got exception:"._nl;
      // echo $e->getMessage()._nl;
      echo "<pre>";
      echo $e;
      echo "</pre>";
    } else {
      ob_end_clean();
      errorHeader();
      trigger_error($e->getMessage(), E_USER_ERROR);
    }
  }
  session_write_close();
