<?php
/**
 * zakladni uzitecny utility a konstanty co se hodej vsude
 *
 * @package basefunc
 * @author fish <fish@archa.cz>
 */

  // newline
  define('_nl',"<br />\n");
  define('_NL',"\n");

  // {{{ pre_print
  /**
   * vypise obsah pole pomoci print_r uvnitr tagu pre
   *
   * @param array $arr
   * @return void
   */
  function pre_print($arr) {
    echo "<pre>";
    print_r($arr);
    echo "</pre>";
  }
  // }}} pre_print


  // {{{ forceNoCache
  /**
   * zakaze cachovani stranky
   *
   * @return void
   */
  function forceNoCache() {
    header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
    header ("Last-Modified: " . gmdate("D, d M 2100 H:i:s") . " GMT");// always modified
    header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
    header ("Pragma: no-cache");                          // HTTP/1.0
  }
  // }}} forceNoCache


  // {{{ safeExit
  /**
   * ulozi session a ukonci beh skriptu
   *
   * @return void
   */
  function safeExit() {
    session_write_close();
    exit;
  }
  // }}} safeExit

  if (!function_exists('getmxrr')) {
    function getmxrr($hostname, &$mxhosts, &$weight=NULL ){
      return(TRUE);
    }
  }
 
  /**
   * ze vstupniho stringu vytahne klicova slova a vrati je oddelena carkou
   *
   * @return array - pole klicovych slov 
   */        
  function calculateKeyWords($string, $KeywordMinOccur=null, $KeywordMinLen=null, $MaxKeywords=null) {
    $Clean = trim(preg_replace('/  +/', ' ', strtolower(strip_tags($string))));
    if (!empty($Clean)) {
      if (is_null($KeywordMinOccur)) {
        $KeywordMinOccur = KEYWORD_MIN_OCCUR;
      }
      if (is_null($MaxKeywords) && KEYWORD_MAX_COUNT>0) {
        $MaxKeywords = KEYWORD_MAX_COUNT;
      }
      if (is_null($KeywordMinLen)) {
        $KeywordMinLen = KEYWORD_MIN_LENGTH;
      }
      $KeywordsCache = array();
      $Words = explode(' ', $Clean);
      foreach ($Words as $Word) {
        if (strlen($Word)>=$KeywordMinLen) {
          if (!array_key_exists($Word, $KeywordsCache)) {
            $KeywordsCache[$Word] = 1;
          } else {
            $KeywordsCache[$Word]++;
          }
        }
      }
      // vybereme jen slova, ktera se vyskytuji alespon $KeywordMinCount krat
      $Keywords = array();
      arsort($KeywordsCache);
      foreach($KeywordsCache as $Word => $Count) {
        if ($Count>=$KeywordMinOccur) {
          $Keywords[] = $Word;
          if ($MaxKeywords>0 && count($Keywords)>=$MaxKeywords) {
            break;
          } 
        } else {
          // mame pole serazene, takze vsechny dalsi uz jsou taky mensi
          break;
        }
      }
      return $Keywords;
    }
    return array();
  }
  
  if (!function_exists('mb_sprintf')) {
    function mb_sprintf($format) {
        $argv = func_get_args() ;
        array_shift($argv) ;
        return mb_vsprintf($format, $argv) ;
    }
  }
  if (!function_exists('mb_vsprintf')) {
    /**
     * Works with all encodings in format and arguments.
     * Supported: Sign, padding, alignment, width and precision.
     * Not supported: Argument swapping.
     */
    function mb_vsprintf($format, $argv, $encoding=null) {
        if (is_null($encoding))
            $encoding = mb_internal_encoding();

        // Use UTF-8 in the format so we can use the u flag in preg_split
        $format = mb_convert_encoding($format, 'UTF-8', $encoding);

        $newformat = ""; // build a new format in UTF-8
        $newargv = array(); // unhandled args in unchanged encoding

        while ($format !== "") {

          // Split the format in two parts: $pre and $post by the first %-directive
          // We get also the matched groups
          list ($pre, $sign, $filler, $align, $size, $precision, $type, $post) =
              preg_split("!\%(\+?)('.|[0 ]|)(-?)([1-9][0-9]*|)(\.[1-9][0-9]*|)([%a-zA-Z])!u",
                         $format, 2, PREG_SPLIT_DELIM_CAPTURE) ;

          $newformat .= mb_convert_encoding($pre, $encoding, 'UTF-8');

          if ($type == '') {
            // didn't match. do nothing. this is the last iteration.
          }
          elseif ($type == '%') {
            // an escaped %
            $newformat .= '%%';
          }
          elseif ($type == 's') {
            $arg = array_shift($argv);
            $arg = mb_convert_encoding($arg, 'UTF-8', $encoding);
            $padding_pre = '';
            $padding_post = '';

            // truncate $arg
            if ($precision !== '') {
              $precision = intval(substr($precision,1));
              if ($precision > 0 && mb_strlen($arg,$encoding) > $precision)
                $arg = mb_substr($precision,0,$precision,$encoding);
            }

            // define padding
            if ($size > 0) {
              $arglen = mb_strlen($arg, $encoding);
              if ($arglen < $size) {
                if($filler==='')
                    $filler = ' ';
                if ($align == '-')
                    $padding_post = str_repeat($filler, $size - $arglen);
                else
                    $padding_pre = str_repeat($filler, $size - $arglen);
              }
            }

            // escape % and pass it forward
            $newformat .= $padding_pre . str_replace('%', '%%', $arg) . $padding_post;
          }
          else {
            // another type, pass forward
            $newformat .= "%$sign$filler$align$size$precision$type";
            $newargv[] = array_shift($argv);
          }
          $format = strval($post);
        }
        // Convert new format back from UTF-8 to the original encoding
        $newformat = mb_convert_encoding($newformat, $encoding, 'UTF-8');
        return vsprintf($newformat, $newargv);
    }
  }
  
  function microtime_float(){
    list($usec, $sec) = explode(" ", microtime());
    return (round(($usec + $sec)*1000));
  }
  
  function prettySql($query) {
    echo _nl._nl;
    echo preg_replace("/ AND /","<br /><b>AND</b> ",preg_replace("/(FROM|WHERE|LEFT JOIN|GROUP BY|ORDER BY)/","<br /><br /><b>$1</b>",htmlspecialchars($query)))._nl;
    echo _nl._nl;
  }
  
  // {{{ defPost
  /**
   * nastavi hodnotu do postu, pokud neni v postu definovana
   *
   * @return void
   */
  function defPost(&$PostField,$val){
    if(!isset($PostField)){
      $PostField=$val;
    }
  }
  
  
  /**
   * Build A XML Data Set
   *
   * @param array $data Associative Array containing values to be parsed into an XML Data Set(s)
   * @param string $startElement Root Opening Tag, default fx_request
   * @param string $xml_version XML Version, default 1.0
   * @param string $xml_encoding XML Encoding, default UTF-8
   * @return string XML String containig values
   * @return mixed Boolean false on failure, string XML result on success
   */
  function buildXMLData($data, $startElement = 'xml', $xml_version = '1.0', $xml_encoding = 'UTF-8', $rowName="row"){
    if(!is_array($data)){
       $err = 'Invalid variable type supplied, expected array not found on line '.__LINE__." in Class: ".__CLASS__." Method: ".__METHOD__;
       trigger_error($err);
       if($this->_debug) echo $err;
       return false; //return false error occurred
    }
    $xml = new XmlWriter();
    $xml->openMemory();
    $xml->startDocument($xml_version, $xml_encoding);
    $xml->startElement($startElement);
  
    /**
     * Write XML as per Associative Array
     * @param object $xml XMLWriter Object
     * @param array $data Associative Data Array
     */
    function write(XMLWriter $xml, $data, $rowName="row"){
        foreach($data as $key => $value){
            if(is_array($value)){
              if (is_int($key)) {
                $xml->startElement($rowName);
                foreach ($value as $attName=>$att) {
                  $xml->writeAttribute($attName, $att);
                }
                $xml->endElement();
                continue;
              } else {
                $xml->startElement($key);
                write($xml, $value, $rowName);
                $xml->endElement();
                continue;
              }
            }
            $xml->writeElement($key, $value);
        }
    }
    write($xml, $data, $rowName);
  
    $xml->endElement();//write end element
    //Return the XML results
    return $xml->outputMemory(true); 
  }  

?>
